package com.sf.service.gateway.domain.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 服务详细信息
 * 
 * @author zoukun
 * @date 2024-04-22
 */
@Data
@ApiModel( description = "服务详细信息展示对象")
public class GatewayServerDetailedVO {
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("服务名称")
    private String serverName;

    @ApiModelProperty("服务地址，路由模式为路由名称")
    private String serverAddress;

    @ApiModelProperty("备注")
    private String remark;

    @ApiModelProperty("服务状态")
    private String status;

    @ApiModelProperty("创建者")
    private String created;

    @ApiModelProperty("更新者")
    private String modified;

    @ApiModelProperty("服务模式（NORMAL=普通模式，ROUTE=路由模式）")
    private String serviceModel;

    @ApiModelProperty("路由规则id")
    private Long routeId;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    /** 更新时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    @ApiModelProperty("包含的接口信息")
    private List<GatewayInterfaceInfoListVO> interfaceInfoList;
}
